#!/usr/bin/perl
# version 11
# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# Restricted Materials of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2002,2003 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
#alphaWorks License Agreement

# Please read this IBM alphaWorks license agreement (called the "Agreement") carefully.
# Your use of the software or any related documentation (called the "Software") indicates
# your acceptance of the following terms and conditions. If you do not agree to these
# terms and conditions, you may not install or use the Software.
#
# Notice: The Software that is made available through the alphaWorks project is not
# generally available software. It has not undergone complete testing and may contain
# errors. It may not function properly and is subject to change or withdrawal at any
# time. No support or maintenance is provided with the Software. Do not install this software
# if you are not accustomed to using experimental software.
#
# The alphaWorks Software is made available without charge in the experimental stage in
# order to allow you to evaluate the Software in its developmental stage. We encourage
# your feedback and suggestions.
#
# 1. Ownership and License.
#
# The Software is owned by International Business Machines Corporation or one of its
# subsidiaries ("IBM") and is copyrighted and licensed, not sold.
#
# IBM grants you a non-exclusive, non-transferable license to download the Software and
# use it only for your personal, non-commercial and lawful end use. Implied licenses are negated.
#
# You may copy the Software for backup only. You may not: 1) merge, distribute (for free or
# for sale) or sublicense the Software; 2) reverse assemble, reverse compile, or
# otherwise translate the Software.
#
# 2. Term and Termination
#
# This Agreement will terminate ninety (90) days after the date on which you receive the
# Software. Upon such termination you will delete or destroy all copies of the Software.
#
# 3. Warranty Disclaimer and Limitation of Liability
#
# IBM licenses the Software to you on an "as is" basis, without warranty of any kind.
# IBM hereby expressly disclaims all warranties or conditions, either express or implied,
# including, but not limited to, the implied warranties or conditions of
# merchantability and fitness for a particular purpose. You are solely responsible for determining
# the appropriateness of using this Software and assume all risks associated with the use of
# this Software, including but not limited to the risks of program errors, damage to or
# loss of data, programs or equipment, and unavailability or interruption of operations.
# Some jurisdictions do not allow for the exclusion or limitation of implied warranties,
# so the above limitations 
# IBM will not be liable for any direct damages or for any special, incidental, or
# indirect damages or for any economic consequential damages (including lost profits
# or savings), even if IBM has been advised of the possibility of such damages.
# IBM will not be liable for the loss of, or damage to, your records or data, or
# any damages claimed by you based on a third party claim. Some jurisdictions do
# not allow for the exclusion or limitation of incidental or consequential damages,
# so the above limitations or exclusions may not apply to you.
#
# 4. License Rights
#
# You hereby grant to IBM an irrevocable license under all intellectual property rights
# (including copyright) to use, copy, distribute, sublicense, display, perform and prepare
# derivative works based upon any feedback, including materials, fixes, error corrections,
# enhancements, suggestions and the like that you provide to IBM.
#
# 5. General
#
# This Agreement is governed by the laws of the State of New York.
#
# This Agreement is the only understanding and agreement we have regarding your use of the
# Software. It supersedes all other communications, understandings or agreements we may have
# had prior to this Agreement.

package ECTlib;
use strict;
use File::Basename;		# for basename
use File::Find;			# for recursive directory support.

$::ECTROOT 	= "/opt/xcat/csm";
$::ECTLIB	= "$::ECTROOT/lib";
#############################################################################
#  GET XCATROOT
#############################################################################
unless($ENV{XCATROOT}){
    $::XCATROOT = "/opt/xcat";
}
$::MPCLIROOT	= "$::ECTROOT/lib/mpcli";
$::TABDB	= "$::ECTROOT/lib/tabdb";
$::NAMETOIP	= "$::ECTROOT/lib/nametoip";
# SYSTEM COMMANDS

$::AWK          = "/bin/awk";
$::EGREP        = "/bin/egrep";
$::GREP         = "/bin/grep";
$::HEAD         = "/usr/bin/head";
$::RPM          = "/bin/rpm";


# GLOBAL VARIABLES

@::JOBS 	= "";
$::VERBOSE	= "";
$::RC;			# exit status
$::BASE		= "";
$::TARGET	= "";

# CSM DATABASE

$::CSMSITE	= "Site";





#############################################################################
#  
# 
#############################################################################
# -- xCAT TABLES --
$::XCATROOTETC  = "$::XCATROOT/etc";
$::APCPTAB      = "$::XCATROOTETC/apcp.tab";
$::APCTAB       = "$::XCATROOTETC/apc.tab";
$::ASMATAB      = "$::XCATROOTETC/asma.tab";
$::BAYTECHTAB   = "$::XCATROOTETC/baytech.tab";
$::CISCO3500TAB = "$::XCATROOTETC/cisco3500.tab";
$::CONSERVERTAB = "$::XCATROOTETC/conserver.tab";
$::CONSERVERCF  = "$::XCATROOTETC/conserver.cf";
$::DBCACH       = "$::XCATROOTETC/db.cache";
$::EMPTAB       = "$::XCATROOTETC/emp.tab";
$::GKH          = "$::XCATROOTETC/gkh";
$::GPFSTAB      = "$::XCATROOTETC/gpfs.tab";
$::MACTAB       = "$::XCATROOTETC/mac.tab";
$::MPATAB       = $::XCATROOT . "/etc/mpa.tab";
$::MPTAB        = $::XCATROOT . "/etc/mp.tab";
$::NODEHMTAB    = "$::XCATROOTETC/nodehm.tab";
$::NODELISTTAB  = "$::XCATROOTETC/nodelist.tab";
$::NODEMODELTAB = "$::XCATROOTETC/nodemodel.tab";
$::NODERESTAB   = "$::XCATROOTETC/noderes.tab";
$::NODETYPETAB  = "$::XCATROOTETC/nodetype.tab";
$::PASSWDTAB    = $::XCATROOT . "/etc/passwd.tab";
$::RTELTAB      = "$::XCATROOTETC/rtel.tab";
$::SITETAB      = $::XCATROOT ."/etc/site.tab";
$::TTYTAB       = "$::XCATROOTETC/tty.tab";
$::VNCTAB	= "$::XCATROOTETC/vnc.tab";


# CSM attributes:
$::SERIALDEVICE;
@::csm13Attrs = ('Hostname','ConsoleMethod',
        'ConsoleSerialDevice','ConsoleServerName','ConsolePortNum',
        'ConsoleServerNumber','HWControlNodeId','HWControlPoint',
        'HWModel', 'HWSerialNum','HWType','InstallAdapterMacaddr',
        'InstallDistributionName', 'InstallDistributionVersion',
        'InstallOSName', 'PowerMethod','ManagementServer');

# sub procedures

#############################################################################
# usage:   
# InPUT: list of flags separated by colons: a:b:c:d: OUTPUT: nothing 
# ACTION: prints usage message with the flags [-a] [-b]... 
#############################################################################

sub usage{
    shift;			# get rid of class name
    my $ar = shift;		# rest of the values are the arugments.

    my @ars = split(":", $ar);
    my $progName = basename($0);
    print STDERR "$progName: ";
    foreach(@ars){
	print STDERR "[ -$_ ] ";
    }
    print STDERR "\n";
    exit 1;
}

=item updateCSMDb

#############################################################################
# updateCSMDb (Update CSM database)
# INPUT: HEx reference to a NodeDef hash that may or may not contain all
# of the CSM user defined attributes.    
# OUTPUT: 
# ACTION: Takes hash and compares with CSM database and finds any differences 
# if there is a difference, then it changes it to the new hash value after
# prompting the user.  
#############################################################################

=cut

sub updateCSMDb{

    # local variables
    my ($hrNewCSMHash,$hrCurrCSMHash,$cmd,$n,$ar,$at,$val);

    shift;
    $hrNewCSMHash = shift;
    $hrCurrCSMHash = &getCurrentCSMDb();
    foreach my $newKey (sort keys %$hrNewCSMHash){
	# csm generally stores nodes by the long name:
	my $newLongKey = (gethostbyname($newKey))[0];
	# must be sure to try shortname and long name.
	unless(defined($hrCurrCSMHash->{$newKey}) || 
	    defined($hrCurrCSMHash->{$newLongKey})){
	    # in this case the node does not exist in the CSM
	    # database, therefore, we can just add it in using
	    # createnode:
	    print "Defining $newKey in CSM database....\n";
	    # form the argument to createnode:
	    my $ar = "$newKey ";
    	    foreach $at (keys %{$$hrNewCSMHash{$newKey}}){
		if($at eq 'Hostname'){ next }
		my $val = $$hrNewCSMHash{$newKey}{$at};
		unless($val){ next }
		$ar .= "$at=$val ";	
	    }
	    # We also need to add the management server to
	    # these attributes so that conserver works:
	    chomp(my $ms = `/bin/hostname`);
	    $ar .="ManagementServer=$ms ";
	    # also need to add the CSM version that is installed:
	    # we only put the VRM (no F)
	    my $csmver = $::CSM_VERSION{'v'} . "." . $::CSM_VERSION{'r'} .
	          "." . $::CSM_VERSION{'m'};
	    $ar .="InstallCSMVersion=$csmver ";
	    $ar .="InstallPkgArchitecture=i386";
	    # The createnode command is used by CSM's definenode.
	    $cmd = "/opt/csm/csmbin/createnode $ar";
	    print "$cmd\n" if $::DEBUG;
	    `$cmd`;
	    next;
	}

	# The Node already exists in CSM so now we need to change
	# the attributes that have been changed.

	$ar = "";
	# go through each attribute and compare.
	foreach $at (@::csm13Attrs){
	    unless($hrNewCSMHash->{$newKey}{$at} eq 
	    	$hrCurrCSMHash->{$newLongKey}{$at}){
		# These attributes are not equal, so 
		# one must change.		
		# but Hostname and Management server we don't care about.
		if($at eq 'Hostname'){ next }
		if($at eq 'ManagementServer'){ next }
		my $newVal = $hrNewCSMHash->{$newKey}{$at};  
	        my $oldVal = $hrCurrCSMHash->{$newLongKey}{$at};
		print "Updating $newKey attribute $at:  $oldVal -> $newVal\n"; 
		$ar .= $at . "::\"$newVal\"";
	      }	
	} 

	if($ar){	
	    # use the chrsrc-api command to change the CSM database.
	    $cmd = "/usr/bin/chrsrc-api -i -s ";
	    $cmd .= "IBM.ManagedNode::\"Hostname IN ('$newLongKey')\"::";	
	    $cmd .= $ar;
	    print "$cmd\n" if $::DEBUG;
	    `$cmd`;
	}
    }    
} 


=item getCurrentCSMDb

#############################################################################
# getCurrentCSMDb (get CSM database)
# INPUT: nothing
# OUTPUT: hash reference to entire CSM database
# ACTION: gets all of the node attributes and puts it into a hash
#############################################################################

=cut

sub getCurrentCSMDb{

    # local variables:
    my(@csmAttrs,$hrCSMHash,$cmd,$node,$line,@vals);

    print "Getting Current CSM configuration...\n";

    $cmd = "/usr/bin/lsrsrc-api -s IBM.ManagedNode::::";
    $cmd .= join('::', @::csm13Attrs); 
    print "$cmd\n" if $::DEBUG;
    chomp(@csmAttrs = `$cmd 2>/dev/null`);    
    
    foreach $line (@csmAttrs){ 
	$node = (split('::', $line))[0];
	@vals = split('::',$line);
	map { $hrCSMHash->{$node}{$_} = shift @vals } @::csm13Attrs;	
    
    } 

    # This code will print out the contents of the hash of nodes.
    if($::DEBUG){ 
	ECTlib->printHoH($hrCSMHash);
    }
    return $hrCSMHash; 
}


=item printHoH

#############################################################################
# printHoH (print Hash of Hash
# INPUT: reference to a hash of hashes
# OUTPUT: nothing
# ACTION: prints out hash of hashes.
#############################################################################

=cut

sub printHoH {
    #local variables
    my ($hoh, $key, $val, $node);
    shift;		# get rid of class name
    $hoh = shift;       # get hash 
    foreach $node (keys %$hoh){
	print "$node:\n";
        foreach $key (keys %{$hoh->{$node}}){
	   $val = $hoh->{$node}{$key};
   	   print "\t$key = $val\n"
	}
	print "\n";
    }
}

=item migrate2CSM 

#############################################################################
# migrate2CSM
# INPUT: nothing
# OUTPUT: nothing
# ACTION: makes xCAT ready for CSM.
#############################################################################

=cut

sub migrate2CSM{
    # local variables
    print "Migrating xCAT configuration files to CSM... \n";
    my (@procs,$osver,$bkdir,$cmd);

    # make back up directory to put our changes and old files.
    $bkdir = "/tmp/bak";
    unless(-d "$bkdir"){
        system("mkdir $bkdir");
    }
    chomp($osver = `$::XCATROOT/lib/getFunction osver`);

    if($osver =~ "rh"){
	my @daemons = ('atftpd', 'conserver');
	foreach my $service (@daemons){
            # stop service and remove old file:
    	    if(-f "/etc/rc.d/init.d/$service"){
	    	# if it's a CSM rpm that is running, ignore it.
	    	if(-d "/opt/$service"){ next; }
            	print "We are going to now stop $service for xCAT\n";
                system("chkconfig --del $service");
	        system("service $service stop");
                chomp(@procs = `ps -ef | grep $service | awk '{print \$2}'`);
                foreach(@procs){ `kill -9 $_` }    
    	    	unless(-f "$bkdir/$service"){
	            print "Moving /etc/rc.d/init.d/$service to $bkdir\n";
	    	    system("mv /etc/rc.d/init.d/atftpd $bkdir");		
	    	}else{
	    	    system("rm -rf /etc/rc.d/init.d/atftpd");
	        }	
    	    }
	}
    }


    # For full installations on xCAT and CSM we may need to copy files over.
    # for example, both CSM and xCAT require that the RedHat 7.3 disks be 
    # copied onto the harddrive.  The problem however, is that they both
    # expect them to be in different directories.  xCAT wants them in
    # /install/rh73 while CSM wants them in /csminstall/Linux/RedHat/7.3/i386
    # We can make hard links to the files to satisfy this dependency.
    # we can't do soft links because then when the file system is exported,
    # the links would be invalid.

    my ($ans,$verified);
    do{ 
      	print "Would you like to link xCAT install files for CSM to use?\n";
	print "(yes is recommended)  [y/n] ";
   	$ans = <STDIN>;
    }while(!($ans =~ /N|n|Y|y/));
    $ans =~ tr/[A-Z]/[a-z]/;
    chomp($ans);
    #print "Answer: $ans\n";
    unless($ans eq "y"){ 
        print "Migration Complete.  You can now install CSM\n";
    	return; 
    }
    # now link xCAT RedHat files to CSM.
    my @redHatVersions = ("7.3", "7.2", "2.1", "8.0");    
    foreach my $vers (@redHatVersions){
        my $count = 0; 
    	(my $xcatVers = $vers) =~ s/\.//;
    	$::BASE = "/install/rh$xcatVers";
    	$::TARGET = "/csminstall/Linux/RedHat/$vers/i386";
    	if((-d "$::BASE") &&
          !(-d "$::TARGET")){
            # make updates directory for CSM
            my $cmd = "mkdir -p $::TARGET/updates";
            system("$cmd");

            find(\&lnk, "$::BASE");
	    
            # Make symbolic link
            $cmd = "ln -sf $::TARGET/RedHat/RPMS $::TARGET/RPMS";
            #print "$cmd\n";
            system("$cmd") unless(-d "$::TARGET/RPMS");
        }
    }

    print "Migration Complete.  You can now install CSM\n";
}

sub lnk{
    my ($f,$cmd,$count);
    $count = 0;
    (my $csmDir = $File::Find::dir) =~ s/$::BASE/$::TARGET/;
    if(-d $_){
        # make new subdirectories
        $cmd = "mkdir -p $csmDir/$_";
        print "linking files under $File::Find::dir\n";
        system("$cmd");
    }else{
        # hard link files so that both can be exported.
        $cmd = "ln $::File::Find::dir/$_ $csmDir/$_";
        #print "$cmd\n";
        system("$cmd");
        $count++;
    }
    return $count;
}




=item yesOrNo

#############################################################################
# yesOrNo
# INPUT: a yes no question for the user to answer
# OUTPUT: 1 for yes, 0 for no 
# ACTION: asks question and converts yes to 1 and no to 0
#############################################################################

=cut

sub yesOrNo {

    shift; 	# get rid of class name
    my $question = shift;
    my ($ans,$verified);
    do{ 
      	print "$question [y/n]\n";
   	$ans = <STDIN>;
    }while(!($ans =~ /N|n|Y|y/));
    $ans =~ tr/[A-Z]/[a-z]/;
    chomp($ans);
    return (($ans eq "y") ? 1 : 0 );
}



#############################################################################
#
# DATABASE CMDS
#
#############################################################################
sub getKeyValueFromTable{
    shift;	# get class name
    my $table = shift;	# get table
    my $key = shift;	# get key
    my $cmd = "$::ECTLIB/lscsmtab -d :: $table";
    if($::VERBOSE){ print "Running cmd: $cmd\n"; }
    chomp(my @tab = `$cmd 2>/dev/null`);
    foreach my $atVal (@tab){
 	my($k,$v) = split("::", $atVal);
	if($k =~ $key){
	    return ($k,$v);
	}    
    }
    return ($key,undef);
}	 


# this code needs to be optomized... do that later.
sub putKeyValueInTable{    
return;
    my $col1=  "Attr";
    my $col2 = "Value";
    shift;	# get class name
    my $table = shift;	# get table
    my $key = shift;	# get key
    my $v = shift;	# get key value
    # first check that the key is not already in the table:
    my(undef,$keyExists) = ECTlib->getKeyValueFromTable($table,$key);
    if(defined($keyExists)){
	# need to replace it:
	my $cmd = "$::ECTLIB/rmcsmrow -w \"$col1 == '$key'\" Site";
	print "$cmd\n" if $::VERBOSE;
	`$cmd`;
    }
    # now put the new key in there:
    
    my $cmd = "$::ECTLIB/mkcsmrow $table $col1=$key $col2=$v";
    if($::VERBOSE){ print "Running cmd: $cmd\n"; }
    `$cmd`;
    my $rc = $?;
    unless($rc >> 8){
	# error in the command... do something!	
    }
    return $rc;
}


# xCAT functions in perl:
# isaip: takes in a questionable ip address.  It parses it to make
# sure that it is one, if it is, then it returns 1, otherwise it returns
# 0 to signal that it is not an ipaddress 
sub isaip{
    shift;	# get rid of class name.
    my @octets = split('\.', @_);
    if($#octets ne 3){ 
	if($::DEBUG){ print "octets not equal to 4\n"; }
	return 0
    }
    foreach my $i (@octets){
	if($i > 254){	
	    return 0;
	}
    }
    return 1;  # this appears to be an ipv4 ip address.
}

sub nametoip{
    shift; # get rid of class name.
    my $ip = shift;
    if(ECTlib->isaip($ip)){
	return $ip; # already is an ip address
    }
    chomp(my $hosts = `getent hosts $ip`);
    if($hosts){
	$ip = (split(' ',$hosts))[0];
    }else{
	return 1;
    }
    print "nametoip: $ip\n" if $::DEBUG;
    return $ip;
}

# tabdb takes in a database (xcat table) a key and an index.
# a key can have several data fields after it.
# returns the val or "no-value" if nothing was found.

sub tabdb{
shift; # get rid of class
my $db = shift; # get db, key, and index.
my $key = shift;
my $index = shift;
print "db: $db, key: $key, index: $index\n" if $::DEBUG;
my $val;
# check that all fields have been defined.
unless(defined($db) && defined($key) && defined($index)){
    print "tabdb: please define a database, a key, and an index";
    $val = "no-value";
}else{
    my $data; # hold the value 
    #my $rec = `egrep "^$key(\b|,)" < $db 2>/dev/null | head -1 2>/dev/null`;
    my $rec = `egrep "^$key" $db 2>/dev/null | head -1 2>/dev/null`;
    chomp($rec);
     # see if the key was there:
    if($? eq 1){
    	$val = "no-value";
    }else{
     	# the key was there, now get the value.
    	$rec =~ tr/\t /,/s;
    	$data= (split(',',$rec))[$index];
    	if($data){
            $val = $data;
    	}else{
            $val = "no-value";
    	}
    }
}
return $val;
}

sub netmask{
}

1;
