#!/bin/ksh
#
# This script is called when a GPFS file system becomes full.
# This script is invoked on the Management Server
# The list of GPFS file systems are passed to this script.
# Environment variables documented in the IBM RSCT for AIX Admin Guide.
#
# ERRM_VALUE will be of the form '/four_raid:26% /home_gpfs:4% /home_emos_gpfs:43% /home_ibm_gpfs:80%'
# if multiple file system are reported.
PERL=/usr/sbin/rsct/perl5/bin/perl
# convert time string
seconds=${ERRM_TIME%,*}

EventTime=$(seconds=$seconds $PERL -e \
'
use POSIX qw(strftime);
print strftime("%a %d/%m/%y %T", localtime($ENV{seconds}) );

'
)

echo "GPFS file systems:$ERRM_VALUE for Node:$ERRM_NODE_NAME reported Full with Sev:$ERRM_COND_SEVERITYID at:$EventTime" >> /csminstall/tools/monitor/act_clean_gpfs_fs.out 2>&1
# Severity is 0 - Info, 1 - Warning , 2 - Critical.

