#!/usr/bin/perl
# -*- perl -*-
#
# @(#)76   1.3   src/xcsm/clone/opt/csm/pm/csmsetupsisOverrides.pm, xcsm, ect_base 10/11/06 05:07:24
#--------------------------------------------------------------------------------

use strict;
our $DEFAULT_SIS_TMPL = "/opt/xcsm/clone/sis.tmpl";

BEGIN {
	# XXX TODO Change these overrides to actual modifications to CSM code.

	# 
	# this file contains symbol table manipulation
	# for more information, see "typeglobs" in the Camel book
	#
	# this file uses goto &subroutine;
	# read your camel book for the implcations of that!


    ###
    ### Assumes that the intended method is "sis"
    ###

	my $DefaultgetTemplateDefaults = \&NodeUtils::getTemplateDefaults;
	*NodeUtils::getTemplateDefaults = sub {
		my ($class, $node, $method) = @_;
		my $routine = "getTemplateDefaults";
		our $DEBUG;
		print "OVERRIDING: $routine\n" if $DEBUG;
		
		my %tmplDefaults;
		my ($default_tmpl, $postfix, $arch);
		my $node_arch = $::NODEHASH{$node}{'InstallPkgArchitecture'};
		
		#if($method eq "sis")
		
		    $default_tmpl = $::DEFAULT_SIS_TMPL;
		    $postfix = "";
		    $arch = $node_arch =~ /i.86/ ? "" : "-$node_arch";
		    $tmplDefaults{default_tmpl} = $default_tmpl;
		    $tmplDefaults{postfix} = $postfix;
		    $tmplDefaults{arch} = $arch;

		    print "LEAVING: $routine\n" if $::DEBUG;
		    return %tmplDefaults;
		
		#goto &$DefaultgetTemplateDefaults;	
	};
	
	###
	### Assumes that the intended type is "sis"
	###

	my $defaultgetInstallFile = \&NodesetUtils::getInstallFile;
	*NodesetUtils::getInstallFile = sub {
	    my $node = shift;
	    my $type = shift;
    
	    my @nodeList = @NodesetUtils::targetNodes;
	    my %nodeHash = %NodesetUtils::nodeHash;

	    my ($node_hostname, $node_ipaddr);
	    if (   $nodeHash{$node}{'InstallAdapterHostname'}
		    && $nodeHash{$node}{'InstallAdapterHostname'} ne '')
	    {
		    ($node_hostname, $node_ipaddr) =
			 NetworkUtils->getHost($nodeHash{$node}{'InstallAdapterHostname'});
	    }
	    else
	    {
		    ($node_hostname, $node_ipaddr) = NetworkUtils->getHost($node);
	    }

	    # Generate a hex representation of each node's ip address.
	    my %hex;
	    if (   $nodeHash{$node}{'InstallAdapterHostname'}
		    && $nodeHash{$node}{'InstallAdapterHostname'} ne '')
	    {
		    %hex = NetworkUtils->genHex($nodeHash{$node}{'InstallAdapterHostname'});
	    }
	    else
	    {
		    %hex = NetworkUtils->genHex($node);
	    }
	    my $node_hex    = $hex{$node_hostname};
	    my $default_dir = "/csminstall";
	    if ($ENV{'CSMINSTALL_ROOT'}) { $default_dir = $ENV{'CSMINSTALL_ROOT'}; }

	    ####
	    #### this is a direct copy/rename from the kickstart method
	    ####
	    {

		    # Kickstart config file directory.
		    # Example:  /csminstall/csm/1.5.0/kickstart.RedHatEL-AS4
		    my $sisfile_hostlink;
		    my $sisfile_dir =
			   "$default_dir/csm/"
			 . $::CSM_VERSION
			 . "/sis."
			 . $::DISTRO_NAME
			 . $::DISTRO_VERSION;
		    MessageUtils->messageFromCat(
										'csmInstall.cat',       $::MSGMAPPATH,
										'csminstall',           'V',
										'IMsgCREATING_KS_FILE', $sisfile_dir
									    );
		    NodesetUtils::mkpath("$sisfile_dir", $::VERBOSE, 0755);

		    my $sisdir_real =
			 $::CSM_VERSION . "/sis." . $::DISTRO_NAME . $::DISTRO_VERSION;
		    my $sisdir_link =
			 "$default_dir/csm/" . $::DISTRO_NAME . $::DISTRO_VERSION;
		    unlink $sisdir_link;
		    symlink $sisdir_real, $sisdir_link;

		    my $sisfile      = $sisfile_dir . "/" . $node_ipaddr . "-sis";
		    my $sisfile_real = $node_ipaddr . "-sis";
		    my $sisfile_link = $sisfile_dir . "/" . $node_ipaddr;
		    if ($node_hostname)
		    {
			   $sisfile_hostlink =
				   $sisfile_dir . "/" . $node_hostname . "-sis";
			}
		    return ($sisfile, $sisfile_real, $sisfile_link, $sisfile_hostlink, undef);

		}
	};

	###
	### Modified from the original sub-routine to just handle the sis type
	###
 
	my $defaultcreateInstallFiles = \&NodesetUtils::createInstallFiles;
	*NodesetUtils::createInstallFiles = sub {
	    my $class = shift;
	    my $type     = shift;          # Which install method are we doing?
	    my $tmpl     = "";
	    
	    my @nodeList = @NodesetUtils::targetNodes;
	    my %nodeHash = %NodesetUtils::nodeHash;

	
	    # Create a file for each node
	    foreach my $node (@nodeList)
	    {
		    my $tmplAttr = $nodeHash{$node}{'InstallTemplate'};

		    # The template name:
		    $tmpl = "$::TEMPLATES_DIR/tmpl/$node.cfg";

		    
		    my ($instFile, $real_file, $link_file, $hostlink_file, $hex_link) =
			 NodesetUtils::getInstallFile($node, $type);
		    unless ($instFile) { print "Could not get an installation file\n"; }
		    # set global variables that will be passed to the
		    # install files
		 
		    NodesetUtils::getVariables($node, $type);
		    

		    # open the Install file and put the whole mess together
		    open(INSTFILE, ">$instFile")
			 || MessageUtils->messageFromCat('csmInstall.cat', $::MSGMAPPATH,
							 'csminstall', 'E2', 'EMsgCANT_WRITE_FILE', $instFile);
		    
		    my $hwmaint_sleep     = 0;
		    my $insert_net_device = 0;
		    my $set_stty          = 0;
		    
		    foreach (&NodesetUtils::subvars($tmpl))
		    {
			   print INSTFILE;
			   
		    }
		    
		    close(INSTFILE);
		    
		    #####
		    ##### Copying the install template to the SIS post-install scripts directory
		    #####
		    {
			   my $script_dir = CSMSIS::get_SIS_config("AUTOINSTALL_SCRIPT_DIR") ."/post-install/";
			   
			   my $target_file = $script_dir."00".$node."-postinstall";
			   
			   my $cmd = "$::CP -r $instFile $target_file";
			   NodeUtils->runcmd($cmd, -2);
			   
		    }
			   
		    my $nameIsIP;
		    if ($nodeHash{$node}{'InstallAdapterHostname'})
		    {
			    $nameIsIP =
				 NetworkUtils->isIpaddr(
									    $nodeHash{$node}{'InstallAdapterHostname'});
		    }
		    else
		    {
			    $nameIsIP = NetworkUtils->isIpaddr($node);
		    }
		    
		    if ($type eq "KickStart" || $tmplAttr =~ /DC.xml/)
		    {
			    unlink $link_file;
			    symlink $real_file, $link_file;
			    if (!$nameIsIP)
			    {
				    unlink $hostlink_file;
				    symlink $real_file, $hostlink_file;
			    }
		    }
	    }
	};

###########################################################################
	###
	### Modified from the original sub-routine to just handle the sis type
	###
 
	my $defaultsetupInstallDHCP = \&NodesetUtils::setupInstallDHCP;
	*NodesetUtils::setupInstallDHCP = sub {
		my $verbose;
                my $bootMethod = $NodesetUtils::bootMethod;
		$verbose = ($::VERBOSE ? "-v" : "");
		if (!($verbose)) { $verbose = ($::VERBOSE ? "-V" : ""); }
		my @nodelist  = @NodesetUtils::targetNodes;
		my $nl_output = join(',', @nodelist);
		if ($bootMethod eq 'kickstart' or $bootMethod eq 'kickstart-upgrade')
		{
			MessageUtils->messageFromCat(
										 'csmInstall.cat',    $::MSGMAPPATH,
										 'csminstall',        'I',
										 'IMsgUPDATING_DHCP', $::DHCPDCONF,
										 $nl_output
										);
		}
		elsif ($bootMethod eq 'autoyast')
		{
			MessageUtils->messageFromCat(
										'csmInstall.cat',             $::MSGMAPPATH,
										'csminstall',                 'I',
										'IMsgUPDATING_DHCP_AUTOYAST', $::DHCPDCONF,
										$nl_output
										);
		}
		elsif ($bootMethod eq 'hwmaint')
		{
			MessageUtils->messageFromCat(
										 'csmInstall.cat',            $::MSGMAPPATH,
										 'csminstall',                'I',
										 'IMsgUPDATING_DHCP_HWMAINT', $::DHCPDCONF,
										 $nl_output
										);
		}
		elsif ( $bootMethod eq 'warewulf')
		{
			MessageUtils->messageFromCat(
										 'csmInstall.cat',            $::MSGMAPPATH,
										 'csminstall',                'I',
										 'IMsgUPDATING_DHCP_WAREWULF', $::DHCPDCONF,
										 $nl_output
										);
		}
		elsif ( $bootMethod eq 'sis' )
		{
		    print"Adding nodes to /etc/dhcpd.conf file for SIS install: /etc/dhcpd.conf.\n";
		}
	    else
		{    
			# Nothing to do for other boot methods.
			return 0;
		}
		my @mac_nodes;
		my @uuid_nodes;
		my @warn_nodes;
		foreach my $node (@nodelist)
		{
			my $mac  = $::NODEHASH{$node}{'InstallAdapterMacaddr'};
			my $uuid = $::NODEHASH{$node}{'UUID'};
			if ($mac)
			{
				push @mac_nodes, $node;
			}
			elsif ($uuid)
			{
				push @uuid_nodes, $node;
			}
			else
			{
				push @warn_nodes, $node;
			}
		}
		if (scalar(@warn_nodes))
		{
			my $nodelist = join(', ', @warn_nodes);
			MessageUtils->messageFromCat(
										 'csmInstall.cat',     $::MSGMAPPATH,
										 'csminstall',         'I',
										 'IMsgNotAddedToConf', $::DHCPDCONF,
										 $nodelist
										);
		}
		my ($fstatus, $cmd);
		if (@mac_nodes)
		{
			my $nodelist = join(",", @mac_nodes);
			$cmd =
			  "$::MAKEDHCP $verbose $nodelist Gateway=$::BOOT_ATTRIBUTES{'Gateway'} Nameservers=$::BOOT_ATTRIBUTES{'Nameservers'} Netmask=$::BOOT_ATTRIBUTES{'Netmask'}";
			my $output_ref = NodeUtils->runcmd($cmd, 0, 1);
			$fstatus = $::RUNCMD_RC;
			my $output = NodeUtils->filter_dhcp_output($output_ref);
			MessageUtils->messageFromCat('csmInstall.cat', $::MSGMAPPATH,
										 'csminstall', 'I', 'IMsgShow_Output',
										 $output);
		}
		if (@uuid_nodes)
		{
			my $nodelist = join(",", @uuid_nodes);
			$cmd =
			  "$::MAKEDHCP $verbose --uuid $nodelist Gateway=$::BOOT_ATTRIBUTES{'Gateway'}";
			my $output_ref = NodeUtils->runcmd($cmd, 0, 1);
			$fstatus = $::RUNCMD_RC;
			my $output = NodeUtils->filter_dhcp_output($output_ref);
			MessageUtils->messageFromCat('csmInstall.cat', $::MSGMAPPATH,
										 'csminstall', 'I', 'IMsgShow_Output',
										 $output);
		}

		return $fstatus;    # 0 is good
	};

	###
	### Modified from the original sub-routine to just handle the sis type
	###
 
	my $defaultsetupDHCP = \&NodesetUtils::setupDHCP;
	*NodesetUtils::setupDHCP = sub {
                my $bootMethod = $NodesetUtils::bootMethod;
		if (defined $ENV{CSM_NO_SETUP_DHCP})
		{
			MessageUtils->messageFromCat('csmInstall.cat', $::MSGMAPPATH,
										 'csminstall', 'I', 'IMsgSKIP_SETUP_DHCP');
			return 0;
		}
		if ($bootMethod eq 'getmacs' || $bootMethod eq 'getmacssnmp')
		{
			return &setupGetmacsDHCP;
		}
		elsif (   $bootMethod eq 'kickstart'
			   || $bootMethod eq 'kickstart-upgrade'
			   || $bootMethod eq 'autoyast'
			   || $bootMethod eq 'hwmaint'
			   || $bootMethod eq 'warewulf'
			   || $bootMethod eq 'sis')
		{
			return &NodesetUtils::setupInstallDHCP;
		}
		elsif (   $bootMethod eq "disk"
			   || $bootMethod eq "getmacsdisk"
			   || $bootMethod eq "you")
		{
			return &setupBootDiskDHCP;
		}
	};
	
	###
	### Modified from the original sub-routine to just handle the sis type
	###
	my $defaultcopyKernel = \&NodesetUtils::copyKernel;
	*NodesetUtils::copyKernel = sub {
                my $bootMethod = $NodesetUtils::bootMethod;
		# Create /tftpboot and set Permissions if not
		if (!-d $::TFTPBOOT)
		{
			mkpath("$::TFTPBOOT");
			NetworkUtils->secureFilePermissions("$::TFTPBOOT", "0110", "0440", 1);
		}

		#for getmac
		#Copy the kernel, ramdisk and pxelinux files needed for MAC address collection
		if ($bootMethod eq 'getmacs')
		{
			&copyGetmacsKernel;
		}
		elsif ($bootMethod eq 'getmacssnmp')
		{
			&copyGetmacsSNMPKernel;
		}	
		elsif ($bootMethod eq 'kickstart' or $bootMethod eq 'kickstart-upgrade')
		{
			&copyKickstartKernel;
		}
		elsif ($bootMethod eq 'autoyast')
		{
			&copyAutoyastKernel;
		}
		elsif ($bootMethod eq 'hwmaint')
		{
			my $hwmaint_flag = 1;
			&copyGetmacsKernel($hwmaint_flag);
		}
		elsif ($bootMethod eq 'sis')
		{
			#&copySISKernel();   #for SIS kernel has been located in /tftpboot/sis
		}
	};

	###
	### Modified from the original sub-routine to just handle the sis type
	###
	my $defaultmakeRAMDisk = \&NodesetUtils::makeRAMDisk;
	*NodesetUtils::makeRAMDisk = sub {
                my $bootMethod = $NodesetUtils::bootMethod;
                my @targetNodes = @NodesetUtils::targetNodes;
	        my %nodeHash = %NodesetUtils::nodeHash;
		if ($bootMethod eq 'getmacs')
		{
			my $hwmaint_flag = 0;
			&makeGetmacsRAMDisk($hwmaint_flag);
		}
		elsif ($bootMethod eq 'getmacssnmp')
		{
			my ($effective_distro_name) =
			  NodeUtils->getEffectiveDistro($::DISTRO_NAME);
			if ($effective_distro_name =~ /RedHat/)
			{
				&dup_drivers($::REDHAT_TOP);
				&makeKickstartRAMDisk();
			}
			else
			{
				&dup_drivers($::SUSE_TOP);
				&makeAutoyastRAMDisk();
			}
		}	
		elsif ($bootMethod eq 'kickstart' or $bootMethod eq 'kickstart-upgrade')
		{
			my $commonRAMDisk = 0;
			&dup_drivers($::REDHAT_TOP);
			foreach my $node (@targetNodes)
			{
				if (!$nodeHash{$node}{InstallAdapterMacaddr}
					&& $nodeHash{$node}{UUID})
				{
					&makeKickstartRAMDisk($node);
				}
				else
				{
					++$commonRAMDisk;
				}
			}
			if ($commonRAMDisk)
			{
				&makeKickstartRAMDisk;
			}
		}
		elsif ($bootMethod eq 'autoyast')
		{
			my $commonRAMDisk = 0;
			&dup_drivers($::SUSE_TOP);
			foreach my $node (@targetNodes)
			{
				if (!$nodeHash{$node}{InstallAdapterMacaddr}
					&& $nodeHash{$node}{UUID})
				{
					&makeAutoyastRAMDisk($node);
				}
				else
				{
					++$commonRAMDisk;
				}
			}
			if ($commonRAMDisk)
			{
				&makeAutoyastRAMDisk;
			}

			#&copyDrivers();	# Maybe we'll need to do this
		}
		elsif ($bootMethod eq 'hwmaint')
		{
			my $hwmaint_flag  = 1;
			my $commonRAMDisk = 0;
			foreach my $node (@targetNodes)
			{
				if (!$nodeHash{$node}{InstallAdapterMacaddr}
					&& $nodeHash{$node}{UUID})
				{
					&makeGetmacsRAMDisk($hwmaint_flag, $node);
				}
				else
				{
					++$commonRAMDisk;
				}
			}
			if ($commonRAMDisk)
			{
				&makeGetmacsRAMDisk($hwmaint_flag);
			}
		}
		elsif ($bootMethod eq 'sis')
		{
			#&makeSISRAMDisk();   #for SIS kernel has been located in /tftpboot/sis
		}
		elsif ($bootMethod eq 'warewulf')

		{
			&dup_drivers($::TOP_DIR);
			&makeWarewulfRAMDisk();
		}
		
	};

	###
	### Modified from the original sub-routine to just handle the sis type
	###
	my $defaultsetupInstall = \&NodesetUtils::setupInstall;
	*NodesetUtils::setupInstall = sub {
		my ($class, $method) = @_;
		if (   $method ne "autoyast"
			&& $method ne "kickstart"
			&& $method ne "kickstart-upgrade"
			&& $method ne "warewulf"
			&& $method ne "you"
			&& $method ne "sis")
		{
			MessageUtils->message('E1', 'EMsgInvalidMethod');
		}
		my $routine = "setup";
		print "ENTERING: $routine\n" if $::DEBUG;
		my ($cmd, $output, $returncode);
		$returncode = 0;

		my @nodeList = @::NODELIST;

		if ($method eq "autoyast")
		{
			unless (@nodeList)
			{
				MessageUtils->message('I', 'IMsgNO_NODES_TO_AUTOYAST_SETUP');
				return 0;
			}
			MessageUtils->message('I', 'IMsgSETUP_YAST');
		}
		elsif ($method eq "kickstart" or $method eq "kickstart-upgrade")
		{
			unless (@nodeList)
			{
				MessageUtils->message('I', 'IMsgNO_NODES_TO_KICKSTART_SETUP');
				return 0;
			}
			MessageUtils->message('I', 'IMsgSETUP_KICKSTART');
		}
		elsif ($method eq "warewulf")
		{
			unless (@nodeList)
			{
					MessageUtils->message('I', 'IMsgNO_NODES_TO_WAREWULF_SETUP');
					#print "no nodes to warewulf setup\n";
					return 0;
			}
			MessageUtils->message('I', 'IMsgSETUP_WAREWULF');
		}
		elsif ($method eq "you")
		{
			unless (@nodeList)
			{
					MessageUtils->message('I', 'IMsgNO_NODES_TO_YOU_SETUP');
					#print "no nodes to you setup\n";
					return 0;
			}
			MessageUtils->message('I', 'IMsgSETUP_YOU');
		}

		$method = "hwmaint" if ($::HWMAINT);
		DCUtils->run_setupBoot($method, 'no', \@nodeList, \%::NODEHASH);

		print "LEAVING: $routine\n" if $::DEBUG;
		return $NodesetUtils::BOOT_EXIT;
	};

}  # end BEGIN
1; # end file
