#!/usr/bin/perl
# -*- perl -*-
#
# @(#)75   1.2   src/xcsm/clone/opt/csm/pm/installSisNodeOverrides.pm, xcsm, ect_base 10/11/06 05:12:40
#--------------------------------------------------------------------------------

use strict;

BEGIN {
	# XXX TODO Change these overrides to actual modifications to CSM code.

	# 
	# this file contains symbol table manipulation
	# for more information, see "typeglobs" in the Camel book
	#
	# this file uses goto &subroutine; for super-extra-added transparency
	# read your camel book for the details.
        @::VALID_INSTALLMETHODS = ('kickstart', 'autoyast', 'warewulf', 'kickstart-upgrade', 'you', 'sis');

	my $DefaultSetNodeTemplate = \&NodeUtils::setNodeTemplate;
	# save a coderef 
	#	(which will be accessible in the anonymous sub, since it's a closure)
	# and replace the call with our own code:
	*NodeUtils::setNodeTemplate = sub {
		my ($class, $method, $ref_node_hash) = @_;
		my $routine = "setNodeTemplate";
		our $DEBUG;
		print "OVERRIDING: $routine\n" if $DEBUG;
		
		return $DefaultSetNodeTemplate->($class,"kickstart",$ref_node_hash)
			if $method eq "sis";

		goto &$DefaultSetNodeTemplate;
	};

	my $getTemplateDefaults = \&NodeUtils::getNodeTemplate;
	*NodeUtils::getNodeTemplate = sub {
		my ($class, $node, $method) = @_;
		my $routine = "getNodeTemplate";
		our $DEBUG;
        print "OVERRIDING: $routine ($method)\n" if $DEBUG;
		
		return "/dev/null" if $method eq "sis"; 
		# XXX hack
		# we don't use a real template for SIS nodes
		goto &$getTemplateDefaults;
	};

	my $DCInstallNode = \&DCAPI::DCinstallnode;
	# eh, we don't use the coderef in this one, but whatever :P
	*DCAPI::DCinstallnode = sub {
		print "OVERRIDING: DCInstallNode\n" if $::DEBUG;
		my ($pkg,	
			$cluster_info_hash,	
			$node_info_hash,
			$server_info_hash,
			$skip_file_load_flag,
			$verboseFlag,
			$bootParams,
			$timeOut,
			$skipServer) = @_;
		local $ENV{'DC_ENVIRONMENT'} ||= 1;
		#XXX look! no futzing about with $unset! 
    
		my ($cluster_hash, $ref_nodehash, $ref_ishash) =
			DCUtils->get_all_info_from_hash(
				$cluster_info_hash,
				$node_info_hash,
				$server_info_hash
				);

		my @req_node_attrs=(
			"Hostname","InstallOSName","InstallDistributionName",
			"InstallDistributionVersion", "InstallPkgArchitecture",
			"InstallAdapterMacaddr","UUID","ManagementServer");
   		my @req_server_attrs=(
			"Hostname","InstallOSName","InstallDistributionName",
			"InstallDistributionVersion","InstallPkgArchitecture",
			"InstallServiceLevel");
				
		DCUtils->check_req_attrs(
			$ref_nodehash,\@req_node_attrs,$ref_ishash,
			 \@req_server_attrs,$skip_file_load_flag);		   	
	    DCUtils->check_deploy_attrs(
			$ref_nodehash,$skip_file_load_flag,$ref_ishash);
    
		DCUtils->start_logging($::__CLUSTER_INFO_HASH{'logfile_DCinstallnode'});

	    ServerUtils->get_OSDefs if($ENV{'DC_ENVIRONMENT'} ne "CSM");
    	if (DCUtils->make_osprereboot_script($ref_nodehash) != 0){
	        # Could not create osprereboot script
    	    #  msg was displayed by subroutine
        	exit ($::GLOBAL_EXIT = 1);
    	}
    	local $ENV{'DSH_REMOTE_CMD'} = DCUtils->getRemoteShell;
		local $ENV{'DCP_COPY_CMD'} = DCUtils->getRemoteCopyCmd;
   		my $ms_port = DCUtils->setInstallMsgPort($ref_nodehash);
		DCUtils->merge_config_info;

		if (%$ref_ishash){ # no install server => empty hash => false
        	$::DEPLOY_ATTR_CHECKED = 1;
	        DCAPI->DCsyncServers(
				$cluster_info_hash,
				$node_info_hash,
				$server_info_hash,
				1, $verboseFlag
				);
    	}
		DCUtils->remove_reboot_ready_file($ref_nodehash);

		# setup NFS
		NetworkUtils->start_nfs($ref_nodehash, $ref_ishash);
		if (NetworkUtils->export_csminstall($ref_nodehash, $ref_ishash) != 0){
			# Could not export.
			MessageUtils->message('E', 'EMsgNO_EXPORT');
			exit ($::GLOBAL_EXIT = 1);
    	}

		if (NodeUtils->isLinux && !($ENV{'CSM_SKIP_COMMON_SUBNET_CHECK'})){
        	# check DHCP daemon on MS if any IS different than MS is being used.
			# This check can be skiPped by users.
			# Only verify DHCP for install methods that actually require dhcp
			while(my ($hostname, $hostref) = each (%$ref_nodehash)){
				my $InstallMethod = $hostref->{'InstallMethod'};
				if ($InstallMethod =~
					/kickstart|kickstart-upgrade|autoyast|warewulf|sis/
					){
					# XXX  IMPORTANT SIS CHANGE HERE
					# TODO Move that regex to, oh, say, CSMDefs.pm
					DCUtils->verify_ms_dhcpd($ref_nodehash, $ref_ishash);
					last;	# Do it for all nodes, but only do it once.
				}
	        } # end while
    	} # end if linux
		my %distro_group_hash;
	    # go through each node and divide them into different distro group

		# XXX No, THIS is how you join a bunch of strings together with colons
		# XXX That other mess was just... ick!
		# XXX This isn't SIS-related but it's really much nicer anyway. :P
                foreach my $hostname (keys %$ref_nodehash)
                {
                    my $hostref = $$ref_nodehash{$hostname};
			my $distro_group = join(":", (
				$hostref->{'InstallDistributionName'},
				$hostref->{'InstallDistributionVersion'},
				$hostref->{'InstallServiceLevel'},
				$hostref->{'InstallPkgArchitecture'},
				$hostref->{'InstallCSMVersion'},
				$hostref->{'InstallMethod'}
			));
			push @{$distro_group_hash{$distro_group}}, $hostname;
                }

		#while(my ($hostname, $hostref) = each (%$ref_nodehash)){
		#	my $distro_group = join(":", (
		#		$hostref->{'InstallDistributionName'},
		#		$hostref->{'InstallDistributionVersion'},
		#		$hostref->{'InstallServiceLevel'},
		#		$hostref->{'InstallPkgArchitecture'},
		#		$hostref->{'InstallCSMVersion'},
		#		$hostref->{'InstallMethod'}
		#	));
		#	push @{$distro_group_hash{$distro_group}}, $hostname;
		#}
		
	    
	    foreach my $distro_group (keys %distro_group_hash){
			#local %::NODEHASH = ();
			my %nodehash;
			local *::NODEHASH = \%nodehash; # just in case
	        (my $distro_name,		#$::DISTRO_NAME, 
			 my $distro_version,	#$::DISTRO_VERSION, 
			 my $service_level,		#$::SERVICE_LEVEL,
			 my $arch, 				#$::ARCH
			 my $csm_version,		#$::CSM_VERSION, 
			 my $install_method 	#$::INSTALL_METHOD
			 ) = split(":", $distro_group);
			my @target_node_list = @{$distro_group_hash{$distro_group}};
			foreach my $node (@target_node_list){
	            $nodehash{$node} = $ref_nodehash->{$node};
			}    
        	# InstallMethod attribute must be common in each cycle.
			# The INSTALL_METHOD is already the same for all the nodes
			# in this group
			# $::INSTALL_METHOD = 
			# DCUtils->common_install_method($ref_nodehash,\@target_node_list);
	        # get the pkgDefs for these attributes
    	    %::lnxpkgdefs =
        	    ServerUtils->get_pkgdefs(
					'Linux', 
					$distro_name, $distro_version, $arch, 
					"MgdNode", $csm_version);

			# Make sure all nodes have valid InstallMethod
			DCUtils->validate_install_method($ref_nodehash,\@target_node_list);           
        	if ($install_method =~
				/kickstart|kickstart-upgrade|autoyast|warewulf|sis/){
					# XXX SIS CHANGE HERE
				DCUtils->full_install(
					\%nodehash, $ref_ishash,\@target_node_list,$bootParams);
			} elsif ($install_method =~ /you/){
				DCUtils->you_upgrade(
					\%nodehash, $ref_ishash,\@target_node_list);
			} else {
				#XXX TODO Someone should print evil warnings here!
		    }
		} # end foreach

	    my @node_list=keys %$ref_nodehash;
    	my $rc = MessageUtils->initialize_status(\@node_list);
	    ($rc) && MessageUtils->message('E2', 'EMsgINIT_STATUS_ERROR');

		# Add node entry in AllowNodeMsgs file
		DCUtils->setAllowNodeMsgs($ref_nodehash);
	    # Start nodestatusd daemon
		DCUtils->start_nodestatusd($ref_nodehash, $ms_port);
	
		if($ENV{'DC_ENVIRONMENT'} ne "CSM"){
   			#Need to write status in non-CSM senario
			#In CSM,this will be done in installnode
			my $msg = MessageUtils->getMessage('IMsgFULL_INSTALL_INITATED');
			foreach my $node (@node_list){ 
				MessageUtils->write_status($node, $msg);
			} # end foreach
		} # end if
	}; # end anonymous sub
}  # end BEGIN
1; # end file
